// opencv_ocean.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <iostream> 
#include "OceanTest.h"
#include "GL/freeglut.h"

static OceanTest ocean;
static double t = 0;
float w[2] = { 0.2, 0.8 };
float scale[3] = { 200, 7.5, 200 }, offset[3] = { 0, 0, 0 };
float choppy = 8.0f;

// ----------------------------------------------------------------------- //

void display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();  //ŁAs񃊃Zbg
	gluLookAt(180.0, 20.0, 0.0, -80.0, -30.0, 0.0, 0.0, 1.0, 0.0);  //_̐ݒ

	// Ct[\
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	// g̍XV
	ocean.updateHeight(t, scale, offset, choppy, 1, 0.01);

	int index;
	float normal[3];
	glColor3f(1, 1, 1);
	glBegin(GL_TRIANGLES);
	for (int i = 0; i < ocean.faceNum; i++)
	{
		for (int j = 0; j < 3; j++)
		{
			index = ocean.indices[3 * i + j];
			glNormal3fv(&ocean.normal[3 * index]);
#if 0
			for (int k = 0; k < 3; k++)
			{
				normal[k] = 0.5 + 0.5*ocean.normal[3 * index + k];
			}
			glColor3fv(normal);
#endif
			glVertex3fv(&ocean.position[3 * index]);
		}
	}
	glEnd();

	// Ԃ̍XV
	t += 0.1;
	glutSwapBuffers();  //obt@̂͂
	glutPostRedisplay(); // ĕ`
}

void init()
{
	glClearColor(0.0, 0.0, 1.0, 1.0);//J[obt@̃NA̐F

	// g̏
	ocean.init(1000, 1000, 256, 256, 31.0, 1.0, w);
	// ǧvZ
	ocean.calculateHeight(0, 1);
	// fobOp摜o
	ocean.height.saveImage("height.png");
	ocean.choppy[0].saveImage("choppyX.png");
	ocean.choppy[1].saveImage("choppyZ.png");
	ocean.normalDft[0].saveImage("normalX.png");
	ocean.normalDft[1].saveImage("normalZ.png");
	// bV̐
	ocean.createMesh(scale, offset, choppy);
}

void reshape(int w, int h)
{
	glViewport(0, 0, w, h);  //r[|[g̐ݒ

	glMatrixMode(GL_PROJECTION);  //s񃂁[hؑ
	glLoadIdentity();
	gluPerspective(20.0, (double)w / (double)h, 1.0, 1000.0); //̐ݒ

	glMatrixMode(GL_MODELVIEW); //s񃂁[h߂

}

void keyboard(unsigned char key, int x, int y)
{
	switch (key)
	{
	case '\x1b': // exit 
		exit(0);
		return;
		// ̃XP[
	case 'a':
		scale[1] -= 0.1f;
		break;
	case 's':
		scale[1] += 0.1f;
		break;
		// choppỹXP[
	case 'z': 
		choppy -= 0.1f;
		choppy = max(0.1f, choppy);
		break;
	case 'x':
		choppy += 0.1f;
		break;
	}
	printf("yscale=%f, choppy=%f\n", scale[1], choppy);
}

int main(int argc, char *argv[])
{

	cout << "Hot keys: \n"
		"\tESC - quit the program\n"
		"\ta - minus y scale\n"
		"\ts - plus y scale\n"
		"\tz - minus choppy scale\n"
		"\tx - plus choppy scale\n";

	glutInit(&argc, argv); //[1]:
	glutInitWindowSize(1800, 900);
	glutCreateWindow("Hello world");//[2]:EBhE쐬

	/** [3]:R[obN֐@o^ **/
	glutDisplayFunc(display); //display֐o^
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	init();

	glutMainLoop();//[4]:C[v

	return 0;
}
